
/*******************************************************************************

	Poverty, Prosperity and Planet Report 2024
	Chapter 1 - Poverty
	*****************************************

	Master do-file

	- Part 1: Folder paths
	- Part 2: Replication code
	
	Written by: Henry Stemmler
	Last date modified: 12 July 2024     
	Stata Version: Stata 18.0
	
*******************************************************************************/

********************************************************************************
* Part 1: Folder paths 
********************************************************************************
*global user	///  // Adjust this path if the main master file is not used
//"C:/Users/`c(username)'/OneDrive - WBG/General - 2024 Poverty and Shared Prosperity Report - WB Group/PPPR_reproducibility/"

global ch1_data 			"$user/Chapter 1/1-data"
global ch1_data_raw 		"$ch1_data/raw"
global ch1_data_processed 	"$ch1_data/processed"
global ch1_output 			"$user/Chapter 1/2-output"
global ch1_code 			"$user/Chapter 1/0-code"

********************************************************************************
* Part 2: Replication code
********************************************************************************
* List for full code
local flist : dir "$ch1_code" files "*.do", respectcase
local master "ch1_0_master.do"
local flist : list flist - master												// No need to run master file again

* List for processed code
local p_flist: dir "$ch1_code" files "ch1_2*.do", respectcase
	
// Run all code if global is set to 1
if ${internal} == 1 {
    foreach fname of local flist {
        do "$ch1_code/`fname'"
    }
}

// Run processed code if global is set to 1
if ${internal} == 0 {
    foreach p_fname of local p_flist {
        do "$ch1_code/`p_fname'"
    }
}

	