
/*******************************************************************************
	Download data from PIP for PPPR 24

	- Part 1: Country, region, income-level and fcs codes
	- Part 2: Population  

	Written by: Henry Stemmler
	Last date modified: 12 July 2024   
	Last date modified: 6 August 2024 (by Samuel Kofi Tetteh Baah)
*******************************************************************************/
* Install PIP

// capture ssc uninstall pip  // uninstalls PIP
// capture ssc install   pip 
// github install worldbank/pip, version(0.10.8.9001) // installs a specified version

********************************************************************************
*	Global and regional poverty 
********************************************************************************
*pip wb, povline(2.15 3.65 6.85 25) clear nowcasts ${pipoptions} 
use "$ch1_data_raw/pip/pip_data_aggregate_202408.dta", clear 
drop if poverty_line == 25
drop poverty_gap poverty_severity watts											// Drop variables not needed
save "$ch1_data_processed/poverty_aggregates.dta", replace

********************************************************************************
*	Country lineup 
********************************************************************************
*pip, povline(2.15 3.65 6.85 25) clear nowcasts ${pipoptions}
use "$ch1_data_raw/pip/pip_data_lineup_202408.dta", clear
drop if poverty_line == 25
drop poverty_gap poverty_severity watts											// Drop variables not needed
save "$ch1_data_processed/poverty_country_lineup.dta", replace

********************************************************************************
*	Country survey 
********************************************************************************
*pip, povline(2.15 3.65 6.85 25) clear ${pipoptions}
use "$ch1_data_raw/pip/pip_data_survey_202408.dta", clear
drop if poverty_line == 25
drop poverty_gap poverty_severity watts											// Drop variables not needed
save "$ch1_data_processed/poverty_country_survey.dta", replace

********************************************************************************
*	Surveys used in PSPR  2022 
********************************************************************************
*pip, clear version(20220909_2017_01_02_PROD) year(last)
use "$ch1_data_raw/pip/pip_data_last_survey_202209.dta", clear
keep welfare_time country_code 
save "$ch1_data_processed/pip_data_pspr22.dta", replace

********************************************************************************
*	Income distribution 
********************************************************************************
/* Code to retrieve data from PIP, uncomment to get raw data
pip, clear povline(0.001 0.01 0.5 1 1.5 2 2.5 3 3.5 4 4.5 5 5.5 6 6.5 7 7.5 8 8.5 9 ///
					9.5 10 10.5 11 11.5 12 12.5 13 13.5 14 14.5 15 15.5 16 ///
					16.5 17 17.5 18 18.5 19 19.5 20 20.5 21 21.5 22 22.5 23 ///
					23.5 24 24.5 25) nowcasts year(1990 2024)  ${pipoptions}
keep country_code reporting_level headcount year population poverty_line
save "$ch1_data_processed/country_income_distribution.dta", replace
					*/
