
********************************************************************************
*	Figure 11. Distribution of subnational poverty rates by income group in 2021
********************************************************************************
use "$ch1_data_processed/gsap_processed.dta", clear
stripplot poor215_ln, over(incg) separate(incg)  height(0.25) center 	   	 	  ///
					  yla(, ang(h)) ytitle("") xtitle("") 						  ///
					  box(barwidth(0.7)) pct(10) jitter(13 13 13 13)			  ///				// IQR box and 90 percentile whiskers
					   ms(O O O O) legend(off)									  ///
					  mcolor("$color3%50" "$color2%50" "$color4%50" "$color7%50") ///
					  mlcolor(none none none none) 	xsize(6)					  ///
					  xtitle("Extreme poverty (%)", size(9pt))
graph export "$ch1_output/ch1_fig11.png", replace
graph export "$ch1_output/ch1_fig11.eps", replace				
export excel "$ch1_output/chapter1.xlsx", sheet("fig11", modify) firstrow(varlabels) cell(A1)
