
/*******************************************************************************

	Poverty, Prosperity and Planet Report 2024
	Chapter 2 - Prosperity
	*****************************************

	Master do-file

	- Part 1: Folder paths
	- Part 2: Replication code
	
	Last date modified: 12 July 2024     
	Stata Version: Stata 17.0
	
*******************************************************************************/

clear
set more off

********************************************************************************
* Part 1: Folder paths 
********************************************************************************
*global user	///  // Adjust this path if the main master file is not used
//"C:/Users/`c(username)'/OneDrive - WBG/General - 2024 Poverty and Shared Prosperity Report - WB Group/PPPR_reproducibility/"

global ch2_input_raw 		"$user/Chapter 2/1-data/raw/"
global ch2_input_processed 	"$user/Chapter 2/1-data/processed/"
global ch2_output 			"$user/Chapter 2/2-output/"
global ch2_figure 			"$user/Chapter 2/2-output/"
global ch2_code 			"$user/Chapter 2/0-code/"

********************************************************************************
* Part 2: Replication code
********************************************************************************
* List for full code
local flist : dir "$ch2_code" files "*.do", respectcase
local master "ch2_0_master.do"
local flist : list flist - master												// No need to run master file again

* List for processed code
local p_flist: dir "$ch2_code" files "ch2_2*.do", respectcase
	
// Run all code if global is set to 1
if ${internal} == 1 {
    foreach fname of local flist {
        do "$ch2_code/`fname'"
    }
}

// Run processed code if global is set to 1
if ${internal} == 0 {
    foreach p_fname of local p_flist {
        do "$ch2_code/`p_fname'"
    }
}

	