/*
figure 10: Share in High, moderate, low inequality over time.
*/

use "$ch2_input_processed/gini_intermediate_all.dta", clear

gen 	band = 1 if giniever<38
replace	band = 2 if inrange(giniever,38,40) 
replace	band = 3 if inrange(giniever,40.00001,42)
replace band = 4 if giniever>42 

gen countrycount = 1
collapse (count) countrycount,  by(year band)

bys year: egen total = total(countrycount)
gen share = countrycount/total * 100
format share %5.0f

keep if inrange(year,2000,2022)
keep year band share

reshape wide share, i(year) j(band) 

label var share1 "Economies with Gini less than 38"
label var share2 "Economies with Gini between 38 to 40" 
label var share3 "Economies with Gini between 40 to 42"
label var share4 "Economies with Gini higher than 42"

format share* %5.0f
export excel using "${ch2_output}Chapter2_data.xlsx", cell(A1) sheet("Fig10") sheetreplace firstrow(varlabel)