/*
Figures 2: Prosperity Gap Trends 2019 - 2024
*/

use "${ch2_input_processed}PG_1981_2024_3pr24.dta", clear
preserve							 									// global prosperity gap 
collapse pg [w=pop], by(year)
gen region_name = "World"
tempfile world 
save 	`world'
restore

collapse pg [w=pop], by(year region_name)								// regional prosperity gap

append using `world'
drop if year < 2019
replace region_name = "Rest of the world" if region_name == "Other High Income Countries"
reshape wide pg, i(region_name) j(year)
drop 	if region_name == ""
forval y = 2019 / 2024 {
    label var pg`y' "`y'"
}
export excel using "${ch2_output}Chapter2_data.xlsx", cell(A1) sheet("Fig2") sheetreplace firstrow(varlabel)