/*
Table 1 An inequality penalty is built into the Prosperity Gap index
*/

* Get PG
use"${ch2_input_processed}PG_surveyestimates_20240802.dta", clear
keep if year==2021 & inlist(country,"BEN","CMR") | year==2022 & inlist(country,"PER","COL")
keep country_code year pg
tempfile pg
save	`pg'

* Get mean income
use"${ch2_input_processed}pip_3pr2024_v20240802.dta", clear
keep if year==2021 & inlist(country_code,"BEN","CMR") | year==2022 & inlist(country_code,"PER","COL")
keep if poverty_line == 25
keep country_code mean
merge 1:1 country_code using `pg', nogen

* Generate inequality
gen ineq = pg * mean/25
order country_code year pg

export excel using "${ch2_output}Chapter2_data.xlsx", cell(A1) sheet("Tab1") sheetreplace firstrow(varlabel)
