/*
Table 2F.1: Gini index in latest available survey, by economy
*/

use "$ch2_input_processed/gini_intermediate_latest.dta", clear

keep country_name region_name welfare_time gini welfare_type

replace region_name = "Rest of the world" if region_name == "Other High Income Countries"

gen 	ginigroup = 2 if gini>40
replace ginigroup = 1 if inrange(gini,30,40)
replace ginigroup = 0 if missing(ginigroup)

gsort -ginigroup country_name
order ginigroup country_name region_name welfare_time welfare_type

format welfare_time* gini* %5.0f
export excel using "${ch2_output}Chapter2_data.xlsx", cell(A1) sheet("Tab2F.1") sheetreplace firstrow(varlabel)