
/*******************************************************************************

	Poverty, Prosperity and Planet Report 2024
	Chapter 3 - Livable Planet
	*****************************************

	Master do-file

	- Part 1: Folder paths
	- Part 2: Replication code
	
	Written by: Henry Stemmler
	Last date modified: 12 July 2024     
	Stata Version: Stata 18.0
	
*******************************************************************************/

********************************************************************************
* Part 1: Folder paths 
********************************************************************************
*global user	///  // Adjust this path if the main master file is not used
//"C:/Users/`c(username)'/OneDrive - WBG/General - 2024 Poverty and Shared Prosperity Report - WB Group/PPPR_reproducibility/"

global ch3_data 			"$user/Chapter 3/1-data"
global ch3_data_raw 		"$ch3_data/raw"
global ch3_data_processed 	"$ch3_data/processed"
global ch3_output 			"$user/Chapter 3/2-output"
global ch3_code 			"$user/Chapter 3/0-code"

********************************************************************************
* Part 2: Replication code
********************************************************************************
* List for full code
local flist : dir "$ch3_code" files "*.do", respectcase
local master "ch3_0_master.do"
local flist : list flist - master												// No need to run master file again

* List for processed code
local p_flist: dir "$ch3_code" files "ch3_2*.do", respectcase
	
// Run all code if global is set to 1
if ${internal} == 1 {
    foreach fname of local flist {
        do "$ch3_code/`fname'"
    }
}

// Run processed code if global is set to 1
if ${internal} == 0 {
    foreach p_fname of local p_flist {
        do "$ch3_code/`p_fname'"
    }
}

	