/*******************************************************************************
	Written by: Henry Stemmler
	Last modified 08 March 2024
*******************************************************************************/

********************************************************************************
*   Import EIA energy data   
********************************************************************************

import delimited "$ch3_data_raw/energy/eia_energy.csv", ///		// Import Energy data
	clear varnames(2)
* Clean
split 	api, parse(-) gen(myvar)												// Extract country code
rename 	myvar3 code
drop	api myvar*
drop if code == ""
rename  v2 sector
foreach v of varlist v* {
   local x : variable label `v'
   rename `v' energy`x'
}
reshape long energy, i(code sector) j(year)
replace energy = "" if inlist(energy, "NA", "ie", "--")
destring energy, replace
replace sector = strtrim(sector)
replace sector = subinstr(sector, " (quad Btu)", "",.)
drop 	if sector == "Nuclear, renewables, and other" 							// Aggregated sector
replace sector = "Total" if sector == "Production"

save "$ch3_data_processed/energy.dta", replace
