/*******************************************************************************
	Import food insecurity related indicators
	
	Written by: Henry Stemmler
	Last modified 23 July 2024
*******************************************************************************/

import delimited "$ch3_data_raw/other/FAOSTAT_data_en_8-5-2024.csv", /// 						// Import data from Wollburg et al. (2023)
	varnames(1) clear
	
keep if item == "Prevalence of undernourishment (percent) (annual value)"	|	///
		item == "Prevalence of moderate or severe food insecurity in the total population (percent) (annual value)"	 |	///
		item == "Percentage of children under 5 years of age who are stunted (modelled estimates) (percent)"
keep yearcode item value

save "$ch3_data_processed/fao_data.dta", replace

