/*******************************************************************************
	Import WASH related indicators
	
	Written by: Henry Stemmler
	Last modified 10 September 2024
*******************************************************************************/
* WASH
wbopendata, indicator(SH.H2O.BASW.ZS; SH.H2O.SMDW.ZS; SH.STA.BASS.ZS; SH.STA.HYGN.ZS; SP.POP.TOTL) year(2022) long clear
drop 	if (region == "" | region == "NA") & countrycode != "WLD"
replace regionname =  "World" if regionname == "Aggregates"
collapse (mean) sh_h2o_basw_zs sh_h2o_smdw_zs sh_sta_bass_zs sh_sta_hygn_zs [aw=sp_pop_totl], by(regionname)					// Population weighted to regional level
order region
save "$ch3_data_processed/wash_data.dta", replace

* WASH rural - urban
wbopendata, indicator(SH.H2O.BASW.UR.ZS; SH.H2O.BASW.RU.ZS; SP.POP.TOTL) year(2022) long clear
drop 	if (region == "" | region == "NA")
drop if sh_h2o_basw_ur_zs == . | sh_h2o_basw_ru_zs == .
save "$ch3_data_processed/wash_ruralurban_data.dta", replace
