
********************************************************************************
* Figure 13. High-income and upper-middle-income countries must lead the transition to net zero  
********************************************************************************
use	"$ch3_data_processed/edgar_ngfs_country_projections.dta", clear
* Merge with country classifications
merge m:1 code using "$ch3_data_processed/countrycodes_current.dta", keep(3) nogen
collapse (mean) emissions_pc [w=pop], by(incgroup_current year scenario)
keep if scenario == "Net Zero 2050" |  scenario == "Current Policies" 
keep if year < 2051
encode  scenario, gen(scen)
drop scenario
reshape wide emissions_pc, i(incgroup_current year) j(scen)
label var emissions_pc1 "Current policies" 
label var emissions_pc2 "Net Zero 2050"
export excel "$ch3_output/chapter3.xlsx", sheet("fig13", modify) firstrow(varlabels)
