
********************************************************************************
* Figure 14. Priorities to advance on the interlinked goals
********************************************************************************
** Emissions
use	"$ch3_data_processed/emissions_edgar_national.dta", clear
* Collapse to country level
collapse (sum) emissions, by(code year)
tempfile emissions 
** GDP Population
merge 1:1 code year using "$ch3_data_processed/gdp.dta", keep(3) nogen
rename code country_code
merge m:1 country_code year using "$ch3_data_processed/pop", keep(3) nogen
rename country_code code
gen 	gdp_pc = gdp / pop
* Merge with country classifications
merge 	m:1 code using "$ch3_data_processed/countrycodes_current.dta", keep(3) nogen
keep if 	year == 2022
* Relevant variables
gen 	emissions_pc = emissions / pop * 1000000							// tons of CO2e
drop if emissions == . | gdp == .
bys 	year (emissions): gen rank = _n
gen 	economy_rank = economy if rank > 186
drop 	rank
bys year (emissions_pc): gen rank = _n
replace   economy_rank = economy if rank > 186 & economy_rank == ""
bys year (gdp_pc): gen rank2 = _n
replace	 economy_rank = economy if rank2 <11 & economy_rank == ""
replace  economy_rank = "" if  inlist(economy_rank, "Somalia", 					///
		"Afghanistan", "Iran, Islamic Rep.", "Russian Federation")
gen 	emissions_label = emissions
replace emissions_label = 10 if emissions < 10									// Create fake emissions for bubble size, because smaller values are not visible
keep 	economy economy_rank incgroup_current emissions_pc gdp_pc emissions emissions_label
sort 	incgroup_current emissions_pc
order 	economy economy_rank incgroup_current emissions_label emissions gdp_pc emissions_pc
* Overview
export excel "$ch3_output/chapter3.xlsx", sheet("fig14", modify) firstrow(varlabels)
