********************************************************************************
* Figure 3A.1. The evolution of World Bank vision and scorecard indicators for food and nutrition security
********************************************************************************
*************************
* a) Prevalence of undernourishment
*************************
use "$ch3_data_processed/fao_data.dta", clear
keep 	if item == "Prevalence of undernourishment (percent) (annual value)"
keep	yearcode value  																
label   var value "Prevalence of undernourishment (%)"
export 	excel "$ch3_output/chapter3.xlsx", sheet("fig3A.1a", modify) firstrow(varlabels)			

*************************
* b) Prevalence of child stunting
*************************
use "$ch3_data_processed/fao_data.dta", clear
keep 	if item == "Percentage of children under 5 years of age who are stunted (modelled estimates) (percent)"
keep	yearcode value 																
label   var value "Prevalence of stunting, height for age (% of children under 5)"
export 	excel "$ch3_output/chapter3.xlsx", sheet("fig3A.1b", modify) firstrow(varlabels)			

************************** 
* c) Prevalence of FIES
*************************
use "$ch3_data_processed/fao_data.dta", clear
keep 	if item == "Prevalence of moderate or severe food insecurity in the total population (percent) (annual value)"
keep	yearcode value 																													
label   var value "Prevalence of moderate or severe food insecurity (%)"
export excel "$ch3_output/chapter3.xlsx", sheet("fig3A.1c", modify) firstrow(varlabels)		
