********************************************************************************
* Figure 3C.1. There are large regional and urban-rural differences in access to water
********************************************************************************
*************************
* a) Regional differences
*************************
use  "$ch3_data_processed/wash_data.dta", clear
order region
label var sh_h2o_basw_zs "Access to basic drinking water (%)"
label var sh_h2o_smdw_zs "Access to safely managed drinking water (%)"								// Note that there is less than 50% coverage for SAR and EAP
label var sh_sta_bass_zs "Access to basic sanitation services (%)"								 
label var sh_sta_hygn_zs "Access to basic hygiene services (%)"								 		// Note that there is less than 50% coverage for ECA, LAC, MNA and NAC
export excel "$ch3_output/chapter3.xlsx", sheet("fig3C.1a", modify) firstrow(varlabels)

*************************
* b) Urban-rural differences
*************************
use "$ch3_data_processed/wash_ruralurban_data.dta", clear
gen add = sh_h2o_basw_ur_zs + sh_h2o_basw_ru_zs									// Generate total for sorting
sencode countrycode, gen(code_n) label(code_l)  gsort(add)						// ordering in figure
sort code_n
keep sh_h2o_basw_ru_zs sh_h2o_basw_ur_zs code_n region
tw  rspike sh_h2o_basw_ru_zs sh_h2o_basw_ur_zs code_n if region != "SSF", lpattern(-) lcolor("$color7")  ///
	|| rspike sh_h2o_basw_ru_zs sh_h2o_basw_ur_zs code_n if region == "SSF", lcolor("$color2") 			 ///
	|| scatter sh_h2o_basw_ru_zs code_n, mc("$color6")  													 ///
	|| scatter sh_h2o_basw_ur_zs code_n, mc("$color20")														 ///
	legend(order(1 "Rest of the world" 2 "Sub-Saharan Africa" 3 "Rural" 4 "Urban") pos(6) row(2))			 ///
	ytitle("Population with basic drinking water access (%)") xtitle("Countries ranked by water access")	 ///
	xlabel("") ysize(5)
graph export "$ch3_output/ch3_fig3C1b.png", replace
graph export "$ch3_output/ch3_fig3C1b.eps", replace

export excel "$ch3_output/chapter3.xlsx", sheet("fig3C.1b", modify) firstrow(varlabels)
