********************************************************************************
* Figure 3D.1. Greenhouse gas emissions and capture from LULUCF
********************************************************************************
use "$ch3_data_processed/emissions_edgar_lulucf.dta", clear

* Merge in country information
merge m:1 code using "$ch3_data_processed/countrycodes_current.dta", keep(3) nogen						// drop small states not in World Bank data
* Aggregate to region level
collapse (sum) emissions2022, by(cscsubsector region)
label  	var emissions2022 "Emissions (megatons CO2e)"
*Keep labels of cscsubsectors
encode 	cscsubsector, gen(cscsubsector_l) label(cscsubsector_l) 
drop 	cscsubsector
levelsof cscsubsector_l, local(l) 
foreach i of local l {
	local d`i'  `: label cscsubsector_l `i''
}
reshape wide emissions2022, i(region) j(cscsubsector_l)
foreach i of local l {
	label var emissions2022`i' "`d`i''"
}
egen	net = rowtotal(emissions2022*)
label 	var net "Net emissions"
export excel "$ch3_output/chapter3.xlsx", sheet("fig3D.1", modify) firstrow(varlabels)

		