********************************************************************************
* Figure 4. For similar levels of exposure, risks vary significantly
********************************************************************************
* Exposure, risk and GDP
use "$ch3_data_processed/exposure_vulnerability_2021.dta", clear
gen year = 2021
** GDP Population
rename code country_code
merge m:1 country_code year using "$ch3_data_processed/pop", keep(3) nogen
rename country_code code
* Generate share of exposed
gen share_exp   = exp_any  / totalpop
gen share_risk  = risk_any / totalpop
label var share_exp  "Share of population exposed to any hazard"
label var share_risk "Share of population at risk from any hazard"
keep  share_exp share_risk totalpop incgroup_current
order share_exp share_risk totalpop incgroup_current
keep if share_risk != .
sort 	incgroup_current
export excel "$ch3_output/chapter3.xlsx", sheet("fig4", modify) firstrow(varlabels)