
********************************************************************************
* Figure 7. A large share of the population in Sub-Saharan Africa exposed to any extreme weather event does not have access to social protection or a financial account 
********************************************************************************
use "$ch3_data_processed/exposure_vulnerability_2021.dta", clear

* Aggregate to region  level
collapse (sum) dep_sp_expany dep_fin_expany totalpop exp_any, by(region)
gen share_risk_sp   = dep_sp_expany / exp_any
gen share_risk_fin  = dep_fin_expany / exp_any
* Cleaning
keep share* region
label var share_risk_sp  "Share of population exposed without social protection"
label var share_risk_fin "Share of population exposed without a financial account"

export excel "$ch3_output/chapter3.xlsx", sheet("fig7", modify) firstrow(varlabels)

