
********************************************************************************
* Figure 8. Limiting temperature increases to 1.5 degrees Celsius by 2050 is still possible, but only with the right set of policies
********************************************************************************
*************************
* a) Emission scenarios
*************************
use "$ch3_data_processed/edgar_ngfs_projections.dta", clear
twoway 	rarea max_range min_range year if scenario=="Nationally Determined Contributions (NDCs)",  color("$color3%50")  || 	///
		rarea max_range min_range year if scenario=="Current Policies",  color("$color1%50") || ///
		rarea max_range min_range year if scenario=="Net Zero 2050",  color("$color6%50") ||  ///
		line  ind year 				   if model   == "Historical", lcolor("$color9")	lwidth(1.4pt) ///
		legend(order(2 "Current Policies" 1 "NDCs" 3 "Net Zero 2050" 4 "Historical") pos(6) row(2)) ///
		ytitle("Relative GHG emissions (2022=1)") xtitle("") ylabel(0(0.2)1.2) xsize(5)
graph export "$ch3_output/ch3_fig8a.png", replace
graph export "$ch3_output/ch3_fig8a.eps", replace

export excel "$ch3_output/chapter3.xlsx", sheet("fig8a", modify) firstrow(varlabels)
*************************
* b) Temperature scenarios
*************************
use "$ch3_data_processed/ngfs_temp_projections.dta", clear
twoway 	rarea max_range min_range year if scenario=="Nationally Determined Contributions (NDCs)",  color("$color3%50")  || 	///
		rarea max_range min_range year if scenario=="Current Policies",  color("$color1%50") || ///
		rarea max_range min_range year if scenario=="Net Zero 2050",  color("$color6%50") ||  ///
		line  ind year 				   if model   == "Historical", lcolor("$color9")	lwidth(1.4pt) ///
		legend(order(2 "Current Policies" 1 "NDCs" 3 "Net Zero 2050" 4 "Historical") pos(6) row(2)) ///
		ytitle("Global mean temperature increase" "(degrees Celcius)") xtitle("") xsize(5)
graph export "$ch3_output/ch3_fig8b.png", replace
graph export "$ch3_output/ch3_fig8b.eps", replace

export excel "$ch3_output/chapter3.xlsx", sheet("fig8b", modify) firstrow(varlabels)
