
********************************************************************************
* Figure b3.2.1a. Exposure and risk in IDA countries (ca. 2021)                     
********************************************************************************

use "$ch3_data_processed/exposure_vulnerability_2021.dta", clear
* Merge country classifications
merge 1:1 code using "$ch3_data_processed/countrycodes_current.dta"
keep if ida_group_current == "IDA"

collapse (sum) exp_any risk_any poor215_any dep_educ_com_expany dep_infra_elec_expany dep_infra_impw_expany dep_sp_expany dep_fin_expany exprai_any totalpop

foreach var of varlist * {
	gen share_`var' = `var' / totalpop
}
keep share*
drop share_totalpop
label var share_exp_any 			  "Exposed to any hazard"
label var share_risk_any 			  "Vulnerable along any dimension"
label var share_poor215_any 		  "Low income"
label var share_dep_educ_com_expany   "Low education level"
label var share_dep_infra_elec_expany "No access to electricity"
label var share_dep_infra_impw_expany "No access to water"
label var share_dep_fin_expany   	  "No access to financial instrument"
label var share_dep_sp_expany   	  "No access to social protection"
label var share_exprai_any   		  "Low access to services and markets"

export excel "$ch3_output/chapter3.xlsx", sheet("figb3.2.1a", modify) firstrow(varlabels) cell(A2)
