
********************************************************************************
* Map 1. Large populations are exposed to extreme weather events in SAR and EAP, and vulnerability is high in SSA
********************************************************************************
use "$ch3_data_processed/exposure_vulnerability_2021.dta", clear
* Aggregate to region  level
collapse (sum) exp_any risk_any totalpop, by(region)
gen share_exp   = exp_any  / totalpop
gen share_risk  = risk_any / totalpop
rename totalpop		pop1
rename exp_any  	pop2
rename risk_any 	pop3
reshape long pop, i(region) j(var)
label define var 1 "Sample population" 2 "Pop. exposed"  3 "Pop. exposed and vulnerable"
label values var var
export excel "$ch3_output/chapter3.xlsx", sheet("map1", modify) firstrow(varlabels)
