
/*******************************************************************************
	Download data from PIP for PPPR 24

	- Part 1: Country, region, income-level and fcs codes
	- Part 2: Population  

	Written by: Henry Stemmler
	Last date modified: 12 July 2024   
	Last date modified: 6 August 2024 (by Samuel Kofi Tetteh Baah)
*******************************************************************************/
* Install PIP

// capture ssc uninstall pip  // uninstalls PIP
// capture ssc install   pip 
// github install worldbank/pip, version(0.10.8.9001) // installs a specified version

********************************************************************************
*	Global and regional poverty 
********************************************************************************
*pip wb, povline(2.15 3.65 6.85 25) clear nowcasts ${pipoptions} 
use "$ch4_data_raw/pip/pip_data_aggregate_202408.dta", clear 
drop if poverty_line == 25
drop poverty_gap poverty_severity watts											// Drop variables not needed
save "$ch4_data_processed/poverty_aggregates.dta", replace

********************************************************************************
*	Country lineup 
********************************************************************************
*pip, povline(2.15 3.65 6.85 25) clear nowcasts ${pipoptions}
use "$ch4_data_raw/pip/pip_data_lineup_202408.dta", clear
drop if poverty_line == 25
drop poverty_gap poverty_severity watts											// Drop variables not needed
save "$ch4_data_processed/poverty_country_lineup.dta", replace

********************************************************************************
*	Country survey 
********************************************************************************
*pip, povline(2.15 3.65 6.85 25) clear ${pipoptions}
use "$ch4_data_raw/pip/pip_data_survey_202408.dta", clear
drop if poverty_line == 25
drop poverty_gap poverty_severity watts											// Drop variables not needed
save "$ch4_data_processed/poverty_country_survey.dta", replace
