
/*******************************************************************************
	Import WID data

/*
Source: https://wid.world/data/
Indicators: post-tax disposable income Gini, top 10% share, top 1% share
Download date: 20204-07-10
*/
*******************************************************************************/
* GINI
import excel using "$ch4_data_raw/WID_Data_10072024-172952.xlsx", clear 
gen code = substr(B,1,17)
keep if code=="gcainc_pall_992_j"												// keep only gini, equal-split total population; post-tax disposable income
ren A country 
ren D year
ren E giniwid
kountry country, from(other) stuck marker
ren _ISO3N_ iso3n
kountry iso3n, from(iso3n) to(iso3c)
ren _ISO3C_ country_code 
replace country_code = "MKD" if country=="North Macedonia"
replace country_code = "XKX" if country=="Kosovo"
keep country_code year giniwid
drop if missing(country_code)													// drops German Democratic Republic which doesn't have iso3c code
replace giniwid = giniwid * 100
save "$ch4_data_processed/wid_data_all.dta", replace

* Top 10% Share
import excel using "$ch4_data_raw/WID_Data_10072024-172952.xlsx", clear 
gen code = substr(B,1,17)
keep if code=="scainc_p90p100_99"												// keep only top 10% share, equal-split total population; post-tax disposable income
ren A country 
ren D year
ren E t10wid
kountry country, from(other) stuck marker
ren _ISO3N_ iso3n
kountry iso3n, from(iso3n) to(iso3c)
ren _ISO3C_ country_code 
replace country_code = "MKD" if country=="North Macedonia"
replace country_code = "XKX" if country=="Kosovo"
keep country_code year t10wid
drop if missing(country_code)													// drops German Democratic Republic which doesn't have iso3c code
replace t10wid = t10wid * 100
save "$ch4_data_processed/wid_data_top.dta", replace
