********************************************************************************
* Figure 3a: ODIN Data scores
************************
use "$ch4_data_processed/odin_data.dta", clear
rename countrycode code
merge 	m:1 code using "$ch4_data_processed/countrycodes_current.dta", keep(3) nogen
keep if datacategories == "All Categories" | datacategories == "Poverty & income"
collapse (median) overallscore, by(datacategories incgroup_current)
encode datacategories, gen(cat) label(cat_l) 
drop   datacategories
* Order income groups
gen 	incg_num = 1 if incgroup_current == "Low-income"
replace incg_num = 2 if incgroup_current == "Lower-middle-income"
replace incg_num = 3 if incgroup_current == "Upper-middle-income"
replace incg_num = 4 if incgroup_current == "High-income"
* Keep labels of regions
levelsof cat, local(l) 
foreach i of local l {
	local d`i'  `: label cat_l `i''
}
* Get in Excel format
reshape wide overallscore, i(incg_num incgroup_current) j(cat)
foreach i of local l {
	label var overallscore`i' "`d`i''"
}
drop incg_num
export excel "$ch4_output/chapter4.xlsx", sheet("fig3a", modify) firstrow(varlabels)



