********************************************************************************
* Figure 3b: ODIN Data scores
************************
use "$ch4_data_processed/odin_data.dta", clear
rename countrycode code
merge 	m:1 code using "$ch4_data_processed/countrycodes_current.dta", keep(3) nogen
keep if datacategories == "All Categories"
collapse (median) coveragesubscore opennesssubscore, by(incgroup_current)
* Order income groups
gen 	incg_num = 1 if incgroup_current == "Low-income"
replace incg_num = 2 if incgroup_current == "Lower-middle-income"
replace incg_num = 3 if incgroup_current == "Upper-middle-income"
replace incg_num = 4 if incgroup_current == "High-income"
sort incg_num
drop incg_num
label var coveragesubscore "Coverage score"
label var opennesssubscore "Openness score" 
export excel "$ch4_output/chapter4.xlsx", sheet("fig3b", modify) firstrow(varlabels)



