/*
Figure 5: Comparing Ginis and Top 10% share between PIP and WID
*/
********************************
*** Comparing PIP v WID gini ***
********************************

use "$ch4_data_processed/gini_intermediate_latest.dta", clear								// from chapter 2 input
keep country_name welfare_type country_code year gini
ren gini ginipip
merge 1:1 country_code year using "$ch4_data_processed/wid_data_all.dta", keep(3) nogen

drop if missing(ginipip) | missing(giniwid)
keep if welfare_type=="income" & year==2021

reshape long gini, i(country* year) j(source) string
encode source, gen(sc)

sum gini if country_name=="Austria" & sc==1
local aut1 = `r(mean)'
sum gini if country_name=="Austria" & sc==2
local aut2 = `r(mean)'
sum gini if country_name=="Belgium" & sc==1
local bel1 = `r(mean)'
sum gini if country_name=="Belgium" & sc==2
local bel2 = `r(mean)'
sum gini if country_name=="Bulgaria" & sc==1
local bgr1 = `r(mean)'
sum gini if country_name=="Bulgaria" & sc==2
local bgr2 = `r(mean)'
sum gini if country_name=="Cyprus" & sc==1
local cyp1 = `r(mean)'
sum gini if country_name=="Cyprus" & sc==2
local cyp2 = `r(mean)'
sum gini if country_name=="Czechia" & sc==1
local cze1 = `r(mean)'
sum gini if country_name=="Czechia" & sc==2
local cze2 = `r(mean)'
sum gini if country_name=="Denmark" & sc==1
local den1 = `r(mean)'
sum gini if country_name=="Denmark" & sc==2
local den2 = `r(mean)'
sum gini if country_name=="Spain" & sc==1
local esp1 = `r(mean)'
sum gini if country_name=="Spain" & sc==2
local esp2 = `r(mean)'
sum gini if country_name=="Estonia" & sc==1
local est1 = `r(mean)'
sum gini if country_name=="Estonia" & sc==2
local est2 = `r(mean)'
sum gini if country_name=="Finland" & sc==1
local fin1 = `r(mean)'
sum gini if country_name=="Finland" & sc==2
local fin2 = `r(mean)'
sum gini if country_name=="United Kingdom" & sc==1
local gbr1 = `r(mean)'
sum gini if country_name=="United Kingdom" & sc==2
local gbr2 = `r(mean)'
sum gini if country_name=="Greece" & sc==1
local grc1 = `r(mean)'
sum gini if country_name=="Greece" & sc==2
local grc2 = `r(mean)'
sum gini if country_name=="Croatia" & sc==1
local hrv1 = `r(mean)'
sum gini if country_name=="Croatia" & sc==2
local hrv2 = `r(mean)'
sum gini if country_name=="Hungary" & sc==1
local hun1 = `r(mean)'
sum gini if country_name=="Hungary" & sc==2
local hun2 = `r(mean)'
sum gini if country_name=="Ireland" & sc==1
local irl1 = `r(mean)'
sum gini if country_name=="Ireland" & sc==2
local irl2 = `r(mean)'
sum gini if country_name=="Italy" & sc==1
local ita1 = `r(mean)'
sum gini if country_name=="Italy" & sc==2
local ita2 = `r(mean)'
sum gini if country_name=="Lithuania" & sc==1
local ltu1 = `r(mean)'
sum gini if country_name=="Lithuania" & sc==2
local ltu2 = `r(mean)'
sum gini if country_name=="Latvia" & sc==1
local lva1 = `r(mean)'
sum gini if country_name=="Latvia" & sc==2
local lva2 = `r(mean)'
sum gini if country_name=="Luxembourg" & sc==1
local lux1 = `r(mean)'
sum gini if country_name=="Luxembourg" & sc==2
local lux2 = `r(mean)'
sum gini if country_name=="Montenegro" & sc==1
local mne1 = `r(mean)'
sum gini if country_name=="Montenegro" & sc==2
local mne2 = `r(mean)'
sum gini if country_name=="Netherlands" & sc==1
local nld1 = `r(mean)'
sum gini if country_name=="Netherlands" & sc==2
local nld2 = `r(mean)'
sum gini if country_name=="Poland" & sc==1
local pol1 = `r(mean)'
sum gini if country_name=="Poland" & sc==2
local pol2 = `r(mean)'
sum gini if country_name=="Portugal" & sc==1
local prt1 = `r(mean)'
sum gini if country_name=="Portugal" & sc==2
local prt2 = `r(mean)'
sum gini if country_name=="Romania" & sc==1
local rou1 = `r(mean)'
sum gini if country_name=="Romania" & sc==2
local rou2 = `r(mean)'
sum gini if country_name=="Serbia" & sc==1
local srb1 = `r(mean)'
sum gini if country_name=="Serbia" & sc==2
local srb2 = `r(mean)'
sum gini if country_name=="Slovak Republic" & sc==1
local svk1 = `r(mean)'
sum gini if country_name=="Slovak Republic" & sc==2
local svk2 = `r(mean)'
sum gini if country_name=="Slovenia" & sc==1
local svn1 = `r(mean)'
sum gini if country_name=="Slovenia" & sc==2
local svn2 = `r(mean)'
sum gini if country_name=="Sweden" & sc==1
local swe1 = `r(mean)'
sum gini if country_name=="Sweden" & sc==2
local swe2 = `r(mean)'


tw 	(line gini sc if country_code=="AUT", color("$color1")) ///
	(line gini sc if country_code=="BEL", color("$color2")) ///
	(line gini sc if country_code=="BGR", color("$color3")) ///
	(line gini sc if country_code=="CYP", color("$color4")) ///
	(line gini sc if country_code=="CZE", color("$color10")) ///
	(line gini sc if country_code=="DNK", color("$color5")) ///
	(line gini sc if country_code=="ESP", color("$color7")) ///
	(line gini sc if country_code=="EST", color("$color8")) ///
	(line gini sc if country_code=="FIN", color("$color9")) ///
	(line gini sc if country_code=="GBR", color("$color10")) ///
	(line gini sc if country_code=="GRC", color("$color1")) ///
	(line gini sc if country_code=="HRV", color("$color2")) ///
	(line gini sc if country_code=="HUN", color("$color3")) ///
	(line gini sc if country_code=="IRL", color("$color4")) ///
	(line gini sc if country_code=="ITA", color("$color5")) ///
	(line gini sc if country_code=="LTU", yaxis(1) lc(none) color("$color6")) ///
	(line gini sc if country_code=="LTU", yaxis(2) color("$color6")) ///
	(line gini sc if country_code=="LUX", color("$color7")) ///
	(line gini sc if country_code=="LVA", color("$color8")) ///
	(line gini sc if country_code=="MNE", color("$color9")) ///
	(line gini sc if country_code=="NLD", color("$color2")) ///
	(line gini sc if country_code=="POL", color("$color1")) ///
	(line gini sc if country_code=="PRT", color("$color2")) ///
	(line gini sc if country_code=="ROU", color("$color3")) ///
	(line gini sc if country_code=="SRB", color("$color4")) ///
	(line gini sc if country_code=="SVK", yaxis(1) lc(none) color("$color5")) ///
	(line gini sc if country_code=="SVK", yaxis(2) color("$color5")) ///
	(line gini sc if country_code=="SVN", color("$color6")) ///
	(line gini sc if country_code=="SWE", color("$color7")), ///
	text(`aut1' 1 "Austria", placement(nw) color("$color1") size(tiny) xoffset(-3)) ///
	text(`bel1' 1 "Belgium", placement(west) color("$color2") size(tiny) xoffset(-3)) ///
	text(`bel2' 2 "Belgium", placement(east) color("$color2") size(tiny) xoffset(+3)) ///
	text(`bgr1' 1 "Bulgaria", placement(west) color("$color3") size(tiny) xoffset(-3)) ///
	text(`bgr2' 2 "Bulgaria", placement(east) color("$color3") size(tiny) xoffset(+3)) ///
	text(`cyp2' 2 "Cyprus", placement(east) color("$color4") size(tiny) xoffset(+3)) ///
	text(`cze2' 2 "Czechia", placement(east) color("$color10") size(tiny) xoffset(+3)) ///
	text(`den2' 2 "Denmark", placement(east) color("$color5") size(tiny) xoffset(+3)) ///
	text(`esp1' 1 "Spain", placement(sw) color("$color7") size(tiny) xoffset(-3)) ///
	text(`est2' 2 "Estonia", placement(east) color("$color8") size(tiny) xoffset(+3)) ///
	text(`fin1' 1 "Finland", placement(west) color("$color9") size(tiny) xoffset(-3)) ///
	text(`gbr2' 2 "United Kingdom", placement(east) color("$color10") size(tiny) xoffset(+3)) ///
	text(`grc2' 2 "Greece", placement(east) color("$color1") size(tiny) xoffset(+3)) ///
	text(`hrv1' 1 "Croatia", placement(sw) color("$color2") size(tiny) xoffset(-3)) ///
	text(`hun1' 1 "Hungary", placement(west) color("$color3") size(tiny) xoffset(-3)) ///
	text(`irl2' 2 "Ireland", placement(east) color("$color4") size(tiny) xoffset(+3)) ///
	text(`ita2' 2 "Italy", placement(ne) color("$color5") size(tiny) xoffset(+3)) ///
	text(`ltu1' 1 "Lithuania", placement(west) color("$color6") size(tiny) xoffset(-3)) ///
	text(`ltu2' 2 "Lithuania", placement(east) color("$color6") size(tiny) xoffset(+3)) ///
	text(`lux2' 2 "Luxembourg", placement(east) color("$color7") size(tiny) xoffset(+3)) ///
	text(`lva1' 1 "Latvia", placement(sw) color("$color8") size(tiny) xoffset(-3)) ///
	text(`mne2' 2 "Montenegro", placement(east) color("$color9") size(tiny) xoffset(+3)) ///
	text(`nld1' 1 "Netherlands", placement(west) color("$color2") size(tiny) xoffset(-3)) ///
	text(`nld2' 2 "Netherlands", placement(east) color("$color2") size(tiny) xoffset(+3)) ///
	text(`pol2' 2 "Poland", placement(east) color("$color1") size(tiny) xoffset(+3)) ///
	text(`prt1' 1 "Portugal", placement(nw) color("$color2") size(tiny) xoffset(-3)) ///
	text(`rou2' 2 "Romania", placement(east) color("$color3") size(tiny) xoffset(+3)) ///
	text(`srb2' 2 "Serbia", placement(east) color("$color4") size(tiny) xoffset(+3)) ///
	text(`svk1' 1 "Slovak Republic", placement(west) color("$color5") size(tiny) xoffset(-3)) ///
	text(`svk2' 2 "Slovak Republic", placement(east) color("$color5") size(tiny) xoffset(+3)) ///
	text(`svn2' 2 "Slovenia", placement(east) color("$color6") size(tiny) xoffset(+3)) ///
	text(`swe1' 1 "Sweden", placement(west) color("$color7") size(tiny) xoffset(-3)) ///
	ytitle("Gini index, PIP", axis(1) xoffset(-5)) ytitle("Gini index, WID", axis(2) xoffset(+5)) xtitle("") ///
	legend(off) xscale(lstyle(none)) xlabel(, nogrid nolabels tlength(0)) ///
	graphregion(margin( l=10 r=10)) name(fig5a, replace) xsize(10) ysize(10)
	
graph combine fig5a, xsize(10) ysize(10)	
graph export "$ch4_output/ch4_fig5a_pip_wid_gini_levels.png", replace	
graph export "$ch4_output/ch4_fig5a_pip_wid_gini_levels.eps", replace	

// save data 
export excel using "$ch4_output/chapter4.xlsx", cell(A1) sheet("fig5a") sheetreplace firstrow(varlabel)	

*********************************************
*** Comparing trends in PIP v WID Top 10% ***
*********************************************

use "$ch4_data_processed/poverty_country_survey.dta", clear
keep if poverty_line == 2.15
keep if reporting_level=="national" | country_code=="ARG"
bys country_code year (welfare_type): gen num = _N								// keep only income series where applicable
bys country_code year (welfare_type): drop if _n==1 & num==2
keep country_name welfare_type country_code year decile10
ren decile10 t10pip
replace t10pip = t10pip * 100
merge 1:1 country_code year using "$ch4_data_processed/wid_data_top.dta", keep(3) nogen

drop if missing(t10pip) | missing(t10wid)
keep if welfare_type==2 

keep if year>=1990
format t10* %5.0f

tw 	line t10pip t10wid year if inlist(country_code,"BGR","LVA","SVK","ROU"), ///
	by(country_name, note("") legend(pos(6))) ///
	ytitle("Share (percent)") xtitle("") legend(row(1) order(1 "PIP top 10% share" 2 "WID top 10% share")) ///
	name(fig5b, replace)
	
graph combine fig5b, xsize(10) ysize(10)	
graph export "$ch4_output/ch4_fig5b_pip_wid_gini_levels.png", replace	
graph export "$ch4_output/ch4_fig5b_pip_wid_gini_levels.eps", replace	

// save data 
export excel using "$ch4_output/chapter4.xlsx", cell(A1) sheet("fig5b") sheetreplace firstrow(varlabel)	
