
/*******************************************************************************

	Poverty, Prosperity and Planet Report 2024
	Overview
	*****************************************

	Master do-file

	- Part 1: Folder paths
	- Part 2: Replication code
	
	Written by: Henry Stemmler
	Last date modified: 12 July 2024     
	Stata Version: Stata 18.0
	
*******************************************************************************/

********************************************************************************
* Part 1: Folder paths 
********************************************************************************
*global user	///  // Adjust this path if the main master file is not used
//"C:/Users/`c(username)'/OneDrive - WBG/General - 2024 Poverty and Shared Prosperity Report - WB Group/PPPR_reproducibility/"

global overview_data			"$user/Overview/1-data"								
global overview_data_raw 		"$overview_data/raw"
global overview_data_processed 	"$overview_data/processed"
global overview_output 			"$user/Overview/2-output"
global overview_code 			"$user/Overview/0-code/"


********************************************************************************
* Part 2: Replication code
********************************************************************************
* List for full code
local flist : dir "$overview_code" files "*.do", respectcase
local master "overview_0_master.do"
local flist : list flist - master												// No need to run master file again

* List for processed code
local p_flist: dir "$overview_code" files "overview_2*.do", respectcase
	
// Run all code if global is set to 1
if ${internal} == 1 {
    foreach fname of local flist {
        do "$overview_code/`fname'"
    }
}

// Run processed code if global is set to 1
if ${internal} == 0 {
    foreach p_fname of local p_flist {
        do "$overview_code/`p_fname'"
    }
}

	