
/*******************************************************************************
	Download and clean data for PPPR 24 Overview

	- Projections

	Written by: Henry Stemmler
	Last date modified: 23 July 2024     
*******************************************************************************/

********************************************************************************
*	Global projections

use "$overview_data_raw/forecasts/FGTglobal_1990_2050_3pr24.dta", clear
keep year povertyline fgt0 scenario poorpop
rename (fgt0 poorpop) (headcount pop_in_poverty)
save "$overview_data_processed/projections_global_2050.dta", replace

********************************************************************************
*	Regional projections

use "$overview_data_raw/forecasts/FGTregion_1990_2050_3pr24.dta", clear
drop if inlist(region_pip, "AFE", "AFW", "WLD") 
keep 	if year > 2024 & year < 2031
keep 	if scenario == "current_forecast"
keep	year fgt0 region_pip povertyline
rename 	(fgt0 region_pip) (headcount region_code)
save "$overview_data_processed/projections_region_2030.dta", replace

********************************************************************************
*	Country projections

use "$overview_data_raw/forecasts/FGTcountry_1990_2050_3pr24.dta", clear
keep 	if scenario == "current_forecast" | scenario == "historical"
keep 	if year > 2024 & year < 2031
keep	code year fgt0 poorpop region_pip fcvFY24 pop povertyline
rename 	(fgt0 poorpop pop) (poverty_rate pop_in_poverty population)
save "$overview_data_processed/projections_country_2030.dta", replace
