/*******************************************************************************
	Import Wollburg et al. (2023) data
	
	Written by: Henry Stemmler
	Last modified 23 July 2024
*******************************************************************************/

** Global
import excel "$overview_data_raw/other/wollburgetal2023.xlsx", /// 						// Import data from Wollburg et al. (2023)
	sheet(Figure2a) firstrow clear
drop E F
rename  (PovertylineinUSDday2017PP WorldBankregion Emissionsincreaserelativetog) ///
		(povertyline region emissions)
drop if povertyline == 3.65
collapse (sum) emissions, by(povertyline Year) 
tostring povertyline, replace
replace povertyline = "$2.15" if povertyline == "2.15"
replace povertyline = "$6.85" if povertyline == "6.85"
save "$overview_data_processed/wollburg_global.dta", replace

** Scenarios
import excel "$overview_data_raw/other/wollburgetal2023.xlsx", /// 						// Import data from Wollburg et al. (2023)
	sheet(Figure3) firstrow clear
label var Allthreepositivescenarioscom "All scenarios"
sort PovertylineinUSDday2017PP Year
save "$overview_data_processed/wollburg_scenarios.dta", replace
