
********************************************************************************
* Figure 14a. IDA countries still lag behind in many dimensions of multidimensional poverty and the population at risk from an extreme weather event in IDA countries is increasing over time
********************************************************************************
**************
* a) Deprivation rates in dimensions of Multidimensional poverty (ca. 2021)
**************
tempfile ida fcs wld
use "$overview_data_processed/pop.dta", clear
keep if year == 2021
rename  country_code code
merge 1:1 code using "$overview_data_processed/mpm_3pr24.dta", keep(3) nogen
keep code dep_monetarypoor dep_educ_com dep_educ_enr 									///
	 dep_infra_elec dep_infra_imps dep_infra_impw2 pop
* Merge country classifications
merge 	m:1 code using "$overview_data_processed/countrycodes_current.dta",				///
		keepusing(region_pip_name ida_group_current fcv_current) keep(3)	nogen		

replace region_pip_name = "Sub-Saharan Africa*" if  region_pip_name == "Sub-Saharan Africa"
replace region_pip_name = "South Asia*" if  region_pip_name == "South Asia"
replace region_pip_name = "East Asia and Pacific*" if  region_pip_name == "East Asia and Pacific"

* IDA
preserve
	collapse (mean) dep* [w=pop], by(ida_group_current)
	rename ida_group_current region_pip_name
	replace region_pip_name = "IDA*" if  region_pip_name == "IDA"
	save `ida'
restore
* FCS
preserve
	collapse (mean) dep* [w=pop], by(fcv_current)
	gsort -fcv_current
	rename fcv_current region_pip_name
	replace region_pip_name = "FCS*" if  region_pip_name 	== "Yes"
	replace region_pip_name = "Non-FCS" if  region_pip_name == "No"
	save `fcs'
restore
* World
preserve
	collapse (mean) dep* [w=pop]
	gen region_pip_name = "World*"
	save `wld'
restore		
* Region
collapse (mean) dep* [w=pop], by(region_pip_name)

append using `wld' `ida' `fcs'
		
label var dep_monetarypoor 	"Monetary"
label var dep_educ_com 		"Educational attainment"
label var dep_educ_enr		"Educational enrollment"
label var dep_infra_elec 	"Electricity"
label var dep_infra_imps 	"Sanitation"
label var dep_infra_impw2 	"Drinking water"

export excel "$overview_output/overview.xlsx", sheet("fig14a", modify) firstrow(varlabels)
