
********************************************************************************
* Figure 9. Limiting temperature increases to 1.5 degrees Celsius by 2050 is still possible, but only with the right set of policies
********************************************************************************
*************************
* a) Emission scenarios
*************************
use "$overview_data_processed/edgar_ngfs_projections.dta", clear
twoway 	rarea max_range min_range year if scenario=="Nationally Determined Contributions (NDCs)",  color("$color3%50")  || 	///
		rarea max_range min_range year if scenario=="Current Policies",  color("$color1%50") || ///
		rarea max_range min_range year if scenario=="Net Zero 2050",  color("$color6%50") ||  ///
		line  ind year 				   if model   == "Historical", lcolor("$color9")	lwidth(1.4pt) ///
		legend(order(2 "Current Policies" 1 "NDCs" 3 "Net Zero 2050" 4 "Historical") pos(6) row(2)) ///
		ytitle("Relative GHG emissions (2022=1)") xtitle("") ylabel(0(0.2)1.2) xsize(5)
graph export "$overview_output/overview_fig9a.png", replace
graph export "$overview_output/overview_fig9a.eps", replace	

export excel "$overview_output/overview.xlsx", sheet("fig9a", modify) firstrow(varlabels)
*************************
* b) Temperature scenarios
*************************
use "$overview_data_processed/ngfs_temp_projections.dta", clear
twoway 	rarea max_range min_range year if scenario=="Nationally Determined Contributions (NDCs)",  color("$color3%50")  || 	///
		rarea max_range min_range year if scenario=="Current Policies",  color("$color1%50") || ///
		rarea max_range min_range year if scenario=="Net Zero 2050",  color("$color6%50") ||  ///
		line  ind year 				   if model   == "Historical", lcolor("$color9")	lwidth(1.4pt) ///
		legend(order(2 "Current Policies" 1 "NDCs" 3 "Net Zero 2050" 4 "Historical") pos(6) row(2)) ///
		ytitle("Global mean temperature increase" "(degrees Celcius)") xtitle("") xsize(5)
graph export "$overview_output/overview_fig9b.png", replace
graph export "$overview_output/overview_fig9b.eps", replace

export excel "$overview_output/overview.xlsx", sheet("fig9b", modify) firstrow(varlabels)
