
********************************************************************************
* Figure 3a Large populations are exposed to extreme weather events in SAR and EAP, and vulnerability is high in SSA
********************************************************************************
use "$summary_data_processed/exposure_vulnerability_2021.dta", clear
* Aggregate to region  level
collapse (sum) exp_any risk_any totalpop, by(region)
gen share_exp   = exp_any  / totalpop
gen share_risk  = risk_any / totalpop
label var share_exp "Population exposed to extreme weather event"
label var share_risk "Population exposed and vulnerable"
keep region share*
replace region = "EAP" if region == "East Asia & Pacific"
replace region = "ECA" if region == "Europe & Central Asia"
replace region = "LAC" if region == "Latin America & Caribbean"
replace region = "MNA" if region == "Middle East & North Africa"
replace region = "NAC" if region == "North America"
replace region = "SAR" if region == "South Asia"
replace region = "SSA" if region == "Sub-Saharan Africa"

* Export
export excel "$summary_output/summary.xlsx", sheet("fig3a", modify) firstrow(varlabels)
