
********************************************************************************
* Figure 3b. Greenhouse gas (GHG) emissions reached record levels in 2022, despite progress in decoupling growth from emissions in some regions
********************************************************************************

use	"$summary_data_processed/emissions_edgar_national.dta", clear
* Collapse to region level
collapse (sum) emissions, by(region year)
replace emissions = emissions / 1000				// megatons to gigatons
label var emissions "Total emissions (gt CO2eq)"

encode 	region, gen(region_l) label(reg_l) 
drop 	region
* Keep labels of regions
levelsof region_l, local(l) 
foreach i of local l {
	local d`i'  `: label reg_l `i''
}
* Get in Excel format
reshape wide emissions, i(year) j(region_l)
foreach i of local l {
	label var emissions`i' "`d`i''"
}
* Export
export excel "$summary_output/summary.xlsx", sheet("fig3b", modify) firstrow(varlabels)
