********************************************************************************
/*
*** Date: 		05/09/2024
*** Author: 	Nishant Yonzan
*** Purpose: 	Income group for FY24 (data year 2022).
*/
********************************************************************************

// income group 2024
use "${rawpath}CLASS_FY24.dta", clear
keep if year_fiscal==2024
keep code region region_pip incgroup_historical ida_historical fcv_historical
duplicates drop
ren region region_wb
ren incgroup_historical incgroupFY24
ren ida_historical 		idaFY24
ren fcv_historical 		fcvFY24

label var incgroupFY24 	"Income group - FY24 list"
label var fcvFY24 		"FCV status - FY24 list"
label var idaFY24 		"IDA status - FY24 list"

replace incgroupFY24 = "LIC"  if incgroupFY24 == "Low income"
replace incgroupFY24 = "LMIC" if incgroupFY24 == "Lower middle income"
replace incgroupFY24 = "UMIC" if incgroupFY24 == "Upper middle income"
replace incgroupFY24 = "HIC"  if incgroupFY24 == "High income"

save "${intermediatepath}IncGroupFY24.dta", replace

********************************************************************************
exit